#include <iostream>
using namespace std;
// Classe Abstrata
class Animal {
protected:
    string nome;
public:
    Animal( const string& nome ) : nome( nome ) {}
    virtual void speak() = 0; // Método Virtual Puro
    string getNome() {
        return nome;
    }
    void setNome( const string& nome ) {
        this->nome = nome;
    }
};

class Dog : public Animal {
public:
    Dog() : Animal( "Dog" ) {}
    virtual void speak() {
        cout << "Woof!" << endl;
    } 
};
class DogAlemao : public Dog {
public:    
    DogAlemao() {
        setNome( "DogAlemao");
    }
    virtual void speak() {
        cout << "Woooooof!" << endl;
    }
};


class Duck : public Animal {
public:
    Duck() : Animal( "Duck" ) {}
    virtual void speak() {
        cout << "Quack!" << endl;
    } 
};

class Cat : public Animal {
public:
    Cat() : Animal( "Cat" ) {}
    virtual void speak() {
        cout << "Meow!" << endl;
    } 
};

int main() {
    Animal * a = new DogAlemao(); 
    a->speak();
    a = new Duck(); // capacidade de assumir diferentes
                    // formas (polimorfismo dinâmico)
    a->speak();
    a = new Dog();
    a->speak();
}
